# Generated by Django 3.2.7 on 2024-04-15 17:15

from django.db import migrations, models
from Gaia import settings
from datetime import datetime, timedelta
from django.db.models import Max, Q, Count
from django.forms import ValidationError

def archive_distributions(apps, schema_editor):
    Distribution = apps.get_model('gaia_distribs', 'Distribution')
    delai = 10
    Distribution.objects.filter(archive=False, date_heure__lt=(datetime.now() - timedelta(days=delai))).update(archive=True)

def archive_contrats(apps, schema_editor):
    Contrat = apps.get_model('gaia_distribs', 'Contrat')
    delai = 35
    date_limite_archivage = datetime.now() - timedelta(days=delai)
    contrats = Contrat.objects.filter(archive=False, date_signature__isnull=False).annotate(
    date_fin=Max("inscriptions__distribution__date_heure"), 
    non_archive=Count("inscriptions__distribution__id", filter=Q(inscriptions__distribution__archive=False), distinct=True),
    ).filter(date_fin__lt=date_limite_archivage, non_archive=0)
    try:
        contrats.update(archive=True)
    except ValidationError:
        pass

class Migration(migrations.Migration):

    dependencies = [
        ('gaia_distribs', '0009_auto_20240323_1324'),
    ]

    operations = [
        migrations.AddField(
            model_name='contrat',
            name='archive',
            field=models.BooleanField(default=False),
        ),
        migrations.AddField(
            model_name='distribution',
            name='archive',
            field=models.BooleanField(default=False),
        ),
        migrations.RunPython(archive_distributions, migrations.RunPython.noop),
        migrations.RunPython(archive_contrats, migrations.RunPython.noop),
    ]
